(function (Drupal) {
  Drupal.behaviors.layoutBuilderAnimations = {
    addAnimation: function (e) {
      e.style.setProperty(
        "--animate-duration",
        e.dataset.animationDuration + "ms"
      );
      e.style.setProperty("--animate-delay", e.dataset.animationDelay + "ms");
      e.classList.add(
        ...[`animate__animated`, `animate__${e.dataset.animationName}`]
      );
    },
    removeAnimation: function (e) {
      e.classList.remove(
        ...[`animate__animated`, `animate__${e.dataset.animationName}`]
      );
    },
    attach: function (context) {
      once("layoutBuilderAnimations", "html", context).forEach(function (
        element
      ) {
        const observer = new IntersectionObserver(
          function (entries, observer) {
            entries.forEach((e) => {
              e.isIntersecting
                ? Drupal.behaviors.layoutBuilderAnimations.addAnimation(
                    e.target
                  )
                : Drupal.behaviors.layoutBuilderAnimations.removeAnimation(
                    e.target
                  );
            });
          },
          {
            threshold: 0.1,
          }
        );
        Array.from(document.querySelectorAll("[data-animation-name]")).forEach(
          (e) => {
            observer.observe(e);
          }
        );
      });
    },
  };
})(Drupal, once);
